// sample for atmega88

#include <avr/io.h>
#include <avr/interrupt.h>


#define BUFSIZE 64 // 2^n size
volatile char spi_rxbuf[BUFSIZE];
volatile char spi_txbuf[BUFSIZE];
volatile uint8_t spi_rxr=0, spi_rxw=0;
volatile uint8_t spi_txr=0, spi_txw=0;

ISR(SPI_STC_vect) {
	uint8_t c=SPDR;
	if (spi_txr!=spi_txw) {
		SPDR = spi_txbuf[spi_txr];
		spi_txr=(spi_txr+1)&(BUFSIZE-1);
	} else {
		SPDR=0;
	}
	if (c) {
		spi_rxbuf[spi_rxw]=c;
		spi_rxw=(spi_rxw+1)&(BUFSIZE-1);
	}
}


void SPI_init_slave() {
	SPCR = (1<<SPE)|(1<<SPIE); // SPI, 荞݋
	DDRB |= (1<<PB4);  /* MISOóA͓͂ɐݒ */
	DDRB &= ~((1<<PB2) | (1<<PB3) | (1<<PB5));  /* MISOóA͓͂ɐݒ */
}

uint8_t spi_recv()
{
	spi_rxr&=(BUFSIZE-1);
	while(spi_rxr==spi_rxw);
	return spi_rxbuf[spi_rxr++];
}

int spi_recv_chk(){
	return spi_rxr!=spi_rxw;
}

void spi_send(uint8_t d)
{
	while(((spi_txw+1)&(BUFSIZE-1))==spi_txr);
	spi_txbuf[spi_txw]=d;
	spi_txw=(spi_txw+1)&(BUFSIZE-1);
}


void spi_puts(char *s) {
	while(*s){
		spi_send(*s);
		s++;
	}
}



// w肳ꂽԂ҂
void wait(uint16_t w){
	while(w--){
		volatile uint16_t i=200;
		while(i--);
	}
}


int main() {

	// 
	DDRB = 0xFF;
	DDRD = 0xFF;
	SPI_init_slave();
	sei();

	int i=0;
	for (;;) {
		wait(1);
		while(spi_recv_chk()) {
			spi_send(spi_recv());
		}
		if (++i==2000) {
			spi_puts("hello!\n");
			i=0;
		}
	}

	return 0;
}

